// function is called from MATLAB as:
// counterCrackLengthToDensity = f_cpp_counterCracks(placedParticles,criticalRatio);

#ifdef _CHAR16T
 #define CHAR16_T
 #endif

#include <yvals.h>
 #if (_MSC_VER >= 1600)
 #define __STDC_UTF_16__
 #endif
 #include "mex.h"
        
#include <math.h>
#include <matrix.h>
#include <mex.h>
#include <cstdlib> // for rand()

namespace mat {
 #include <matrix.h>
 }

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]) {
    
// declare variables
    mxArray *placedParticles_in, *criticalRatio_in, *counterCrackLengthToDensity_out;
    const mwSize *dimsPlacedParticles;

    double *placedParticles, *criticalRatio, *counterCrackLengthToDensity; 
    int nRowsPlacedParticles, nColsPlacedParticles, numdimsPlacedParticles;
    
// associate inputs
    placedParticles_in = mxDuplicateArray(prhs[0]);
    criticalRatio_in = mxDuplicateArray(prhs[1]);
    
// figure out dimensions of individual arrays
    dimsPlacedParticles = mxGetDimensions(prhs[0]);
    numdimsPlacedParticles = mxGetNumberOfDimensions(prhs[0]);
    nRowsPlacedParticles = (int)dimsPlacedParticles[0]; 
    nColsPlacedParticles = (int)dimsPlacedParticles[1];
    
// associate outputs
    counterCrackLengthToDensity_out = plhs[0] = mxCreateDoubleMatrix(1, 1, mxREAL); // mxCreateDoubleMatrix(nRows, nCols, mxREAL)
    
// access variables
    placedParticles = mxGetPr(placedParticles_in);
    criticalRatio = mxGetPr(criticalRatio_in);
    counterCrackLengthToDensity = mxGetPr(counterCrackLengthToDensity_out);
    
// the code
    // mexPrintf("element[%d][%d] = %f\n", j, i, a[i*dimy+j]);
    
    int j, m;
    double center [3], centerOther [3], radius, radiusOther, minDist, meanDiameter, geomRatio;
    
    counterCrackLengthToDensity[0] = 0;
    for (j = 0; j <= nRowsPlacedParticles; j++) {
        center[0] = placedParticles[j];
        center[1] = placedParticles[nRowsPlacedParticles+j];
        center[2] = placedParticles[2*nRowsPlacedParticles+j];
        radius = placedParticles[3*nRowsPlacedParticles+j];
        
        for (m = 0; m < j; m++) {
            centerOther[0] = placedParticles[m];
            centerOther[1] = placedParticles[nRowsPlacedParticles+m];
            centerOther[2] = placedParticles[2*nRowsPlacedParticles+m];
            radiusOther = placedParticles[3*nRowsPlacedParticles+m];
            
            minDist = sqrt((center[0]-centerOther[0])*(center[0]-centerOther[0])+(center[1]-centerOther[1])*(center[1]-centerOther[1])+(center[2]-centerOther[2])*(center[2]-centerOther[2]))-radius-radiusOther;
            // check whether the crack forms
            meanDiameter = radius+radiusOther;
            geomRatio = minDist/meanDiameter;
            
            if (geomRatio < criticalRatio[0]) {
                counterCrackLengthToDensity[0] = counterCrackLengthToDensity[0]+(minDist/2)*(minDist/2)*(minDist/2);
            }
        }   
    }  
    return;
}
