// function is called from MATLAB as:
// placedParticles = f_cpp_placeParticles(particles,cubeSizeRVE,minDistBetweenGrains,periodicBC);

#ifdef _CHAR16T
 #define CHAR16_T
 #endif

#include <yvals.h>
 #if (_MSC_VER >= 1600)
 #define __STDC_UTF_16__
 #endif
 #include "mex.h"
        
#include <math.h>
#include <matrix.h>
#include <mex.h>
#include <cstdlib> // for rand()

namespace mat {
 #include <matrix.h>
 }

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]) {
    
// declare variables
    mxArray *particles_in, *cubeSizeRVE_in, *minDistBetweenGrains_in, *placedParticles_out;
    const mwSize *dimsParticles;

    double *particles, *minDistBetweenGrains, *placedParticles, *cubeSizeRVE; 
    int nRowsParticles, nColsParticles, numdimsParticles;
    
// associate inputs
    particles_in = mxDuplicateArray(prhs[0]);
    cubeSizeRVE_in = mxDuplicateArray(prhs[1]);
    minDistBetweenGrains_in = mxDuplicateArray(prhs[2]);
    
// figure out dimensions of individual arrays
    dimsParticles = mxGetDimensions(prhs[0]);
    numdimsParticles = mxGetNumberOfDimensions(prhs[0]);
    nRowsParticles = (int)dimsParticles[0]; 
    nColsParticles = (int)dimsParticles[1];
    
// associate outputs
    placedParticles_out = plhs[0] = mxCreateDoubleMatrix(nRowsParticles, 4*nColsParticles, mxREAL);
    
// access variables
    particles = mxGetPr(particles_in);
    cubeSizeRVE = mxGetPr(cubeSizeRVE_in);
    minDistBetweenGrains = mxGetPr(minDistBetweenGrains_in);
    
    placedParticles = mxGetPr(placedParticles_out);
    
// the code    
    double radius, center [3], r1, r2, r3, deltaCenter;
    int j, k, test;
    
    for (j = 0; j < nRowsParticles; j++) {
        radius = particles[j]/2;
        // mexPrintf("r = %f \n",radius);
        test = 0;
        while (test == 0) {
            r1 = ((double) rand()/(RAND_MAX));
            r2 = ((double) rand()/(RAND_MAX));
            r3 = ((double) rand()/(RAND_MAX));
            
//             if (periodicBC[0]) {
                center[0] = cubeSizeRVE[0] * r1;
                center[1] = cubeSizeRVE[0] * r2;
                center[2] = cubeSizeRVE[0] * r3;
//             }
//             else {
//                 center[0] = radius+(cubeSizeRVE[0]-2*radius)*r1;
//                 center[1] = radius+(cubeSizeRVE[0]-2*radius)*r2;
//                 center[2] = radius+(cubeSizeRVE[0]-2*radius)*r3;
//             }
            
            placedParticles[j] = center[0];
            placedParticles[nRowsParticles+j] = center[1];
            placedParticles[2*nRowsParticles+j] = center[2];
            placedParticles[3*nRowsParticles+j] = radius;
            
            if (j == 0) {
                test = 1;
                goto stop1;
            }
            else {
                for (k = 0; k < j; k++) {
                    deltaCenter = sqrt((center[0]-placedParticles[k])*(center[0]-placedParticles[k])+(center[1]-placedParticles[nRowsParticles+k])*(center[1]-placedParticles[nRowsParticles+k])+(center[2]-placedParticles[2*nRowsParticles+k])*(center[2]-placedParticles[2*nRowsParticles+k]));

                    if (radius+placedParticles[3*nRowsParticles+k]+minDistBetweenGrains[0] < deltaCenter) {
                        test = 1;
                    }
                    else {
                        test = 0;
                        goto stop2;
                    }
                }
            }
        stop2:;    
        }
    stop1:;
    }    
    return;
}
