function [E nu] = f_E_and_nu_from_K_and_G(K,G)
%
% Young's modulus (E) and Poisson's ratio (nu) from bulk modulus (K) and 
% shear modulus (G)
% f_L_from_K_and_G(K,G)
%
% input: bulk modulus (K) [Pa]
%        shear modulus (G) [Pa]
%
% output: Young's modulus (E) [Pa]
%         Poisson's ratio (nu) [-]
%
% written by Venca 05/05/2012

E = 9*K*G/(3*K+G);
nu = (3*K-2*G)/(2*(3*K+G));

end




                          