function E = f_E_from_L(L)

%
% Assembly of the stiffness matrix
% E_from_L(L)(L)
%
% input: phase stiffness matrix (L) [Pa]
%
% output:Young's modulus E [Pa]
%
% written by Venca 9/8/2011


nu = L(1,2)/(L(1,1)+L(1,2));
E = L(1,1)*(1+nu)*(1-2*nu)/(1-nu);

end