%% Input materials (25/2/2013)
% input for the program
% by Vaclav Nezerka

input_name = 'mortarSand_ITZ';

%% Input parameters for individual phases 

% matrix:
materials(1).name = 'matrix';
materials(1).code = 'matrix';

materials(1).m = 1.46; % mass portion in the mixture [kg]
materials(1).rho = 1066; % bulk density [kg/m^3]
materials(1).E = 6900e6; % Young's modulus [Pa]
materials(1).nu = 0.25; % Poisson's ratio [-]

% sand:
materials(2).name = 'sand';
materials(2).code = 'coated';
materials(2).ID = 1; % it must be in agreement with a corresponding coating

materials(2).m = 1.162; % mass portion in the mixture [kg]
materials(2).rho = 2720; % density [kg/m^3]
materials(2).E = 60000e6; % Young's modulus [Pa]
materials(2).nu = 0.17; % Poisson's ratio [-]

materials(2).GC.frac = [0.125,0.25;
                        0.25,0.5
                        0.5,1;
                        1,2;
                        2,4]*1e-3; % grading cuve - fractions (diameter) [m]
materials(2).GC.amount = [24;
                          45;
                          60;
                          66;
                          30]; % number of grains from each interval(mass, volume) [-]

materials(2).n_in_fraction = 2; % number of fractions within one fraction interval

% ITZ:
materials(3).name = 'ITZ';
materials(3).code = 'coating';
materials(3).ID = 1; % it must be in agreement with a corresponding coated particle

materials(3).rho = materials(1).rho*0.80; % density [kg/m^3]
materials(3).E = materials(1).E*0.70; % Young's modulus [Pa]
materials(3).nu = materials(1).nu*0.70; % Poisson's ratio [-]
materials(3).thickness = 10e-6; % thickness of coating [m] 
materials(3).p_i = 0; % percentage of inclusion consumed by coating;
materials(3).p_m = 100; % percentage of matrix consumed by coating;
materials(3).p_v = 0; % percentage of voids consumed by coating;